package gov.nasa.gsfc.dqss;

import gov.nasa.gsfc.dqss.castor.QueryOutput;


import java.util.Enumeration;
import java.util.List;

import ncsa.hdf.object.Dataset;

public class AIRSDataFile extends DataFile {
    

	
	public AIRSDataFile(String inputFile) {
		super(inputFile);
		// TODO Auto-generated constructor stub
	}
	public AIRSDataFile(String inputFile, String outputFile) {
		super(inputFile,outputFile);
		// TODO Auto-generated constructor stub
	}

	public AIRSDataFile(String inputFile, int doSD) {
		super(inputFile, doSD);
		// TODO Auto-generated constructor stub
	}

	

	  public void updateMember(List<String> list, String name,String castorValue) {

		  if (castorValue == null) {
			  return;
		  }
		  if (castorValue.length() > 0) {
			  list.add(castorValue);
			  logger.debug(name + 
					  " size:" + list.size() + " added value:" + castorValue + ".");
			  
			  if (castorValue.contains("CoordinateConstraintVariable")) {
		    		++nCoordCons;
		    		logger.debug("nCoordCons:"+ nCoordCons);
		      }
			  else if (castorValue.contains("QualityLevelVariable")) {
		    		++nQualLevel;
		    		logger.debug("nQualLevel:" + nQualLevel);
		    	}
			  else if (castorValue.contains("ReferenceConstraintVariable")) {
		    		++nConsRef;
		    		logger.debug("nConsRef:"+ nConsRef);
		    	}
			  else if (castorValue.contains("ReferenceVariable")) {
		    		++nRef;
		    		logger.debug("nRef:" + nRef);
		    	}
			  else if (castorValue.contains("constraint_relationship")) {
				  
			  }
		  }
	  }
	  public void updateLongMember(List<Long> list, String name, String castorValue) {
		  logger.debug(name + ":" + castorValue);
		   if (castorValue != null) {
			   if (castorValue.length() > 0) {
				   long x = Long.parseLong(castorValue);
				   list.add(x);
				   logger.debug(name + 
							  " size:" + list.size() + " added value:" + castorValue + ".");
				  
				  
			   }
		   }
		 
	  }
	  
	  public Dataset[] getQSVars() {
	    	 
	    	Dataset[] qsDatasets = new Dataset[qs_names.size()]; 
	    	
	    	logger.debug("Number of quality datasets:" + qs_names.size());
	    	/*
	    	 * Handy place to get Quality Dataset names.
	    	 */
	    	qualityNames = "";
	    	for (int i = 0; i < qs_names.size(); i++) {
	    		if (qs_names.get(i).length() > 1) {
	    	    	 logger.debug("Doing:" + qs_names.get(i));
	    	    	 qualityNames += qs_names.get(i) + " ";
	    	         qsDatasets[i] = getDataset(qs_names.get(i), topGroup);
	    	         if (qsDatasets[i] == null) {
	    		        if (i < nDatasets) {
	    			         logger.error("Quality dataset:" + qs_names.get(i) + " does not exist in the hdf file");
	    		            return null;
	    		        }
	    	         }
	    	         if (qsDatasets[i] == null) {
	    	        	 logger.error("Quality dataset:" + qs_names.get(i) + " does not exist in the hdf file");
	    	        	 return null;
	    	         }
	    	         logger.debug("getQSVars:" + ((Dataset) qsDatasets[i]).getName());
	    	     }
	    	
	    	}	
	    	return  qsDatasets;
	  }
	  
	  /*
	   * MODAPS Arch:
	   * When we do it this way we no longer have the Best and Good
	   * strings as the ontology returns an integer.
	   */
	  public String ReEngCriteria(QueryOutput[] qos) {
		
		  int i = 0;
		  while (i < qos.length ) {
			  
			  if (qos[i].getLevel() != null) {
				  if (qos[i].getLevel().contains("0")) {
					  logger.debug("Added Criteria Best to criteria array (" + i + ")" );
					  return "Best";
				  }
				  else if (qos[i].getLevel().contains("1")) {
					  logger.debug("Added Criteria Good to criteria array (" + i + ")" );
					  return "Good";
				  }
				  else if (qos[i].getLevel().contains("2")) {
					  return DQSS.NoScreeningString;
				  }
				  else if (qos[i].getScreenVarType().contains("QualityLevel")) {
					  logger.error(qos[i].getScreeningVariable() + " is a " +
							  qos[i].getScreenVarType() + "and so is supposed to have a level associated with it." +
							  " Check input parms. Level:" + qos[i].getLevel() ) ;
				  }
				  else {
					  logger.warn(qos[i].getScreeningVariable() + " is a " +
							  qos[i].getScreenVarType() + " and so doesn't have a level");
					  
				  }
			  }
			  logger.warn("So...Could not find criteria level for "  + qos[i].getScreeningVariable());
			  ++i;
	    
		    	
	  }
	  return "Not Found";
	  }
}

