package gov.nasa.gsfc.dqss;

import java.lang.reflect.Method;
import java.util.HashMap;
import java.util.List;

import org.apache.log4j.Logger;

import ncsa.hdf.object.Dataset;

public class Mask1D1Q1Ref extends Mask {
	
	  static Logger logger = Logger.getLogger(Mask1D1Q1Ref.class.getName());
	
	  DataFile file;
	    
	  public Mask1D1Q1Ref(Dataset data, Dataset[] quality, DataFile File, 
			 String dir) {
			super(data,quality,dir,File);
	    file = File;
	}
	  public void doMask_reflect() throws Exception
	  {
		    int indexOffset = 1;
		    float[] qual = null; 
		    float[] ref =  null;
		      
		    if (file.get_qs_types().get(0).equals("ReferenceConstraintVariable")) {
		    	logger.debug("Using " + quality[0].getName() + " for quality" );
		    	qual = (float[]) quality[0].read();
		    	ref = (float[])  quality[1].read();
		    }
		    else {
		    	logger.debug("Using " + quality[1].getName() + " for quality" );
		    	ref = (float[]) quality[0].read();
		    	qual = (float[])  quality[1].read();
		    	
		    }
		    ReflectDirections rf = new ReflectDirections();
			 //CC
		     Method refl = rf.getMethod(file.qs_coordcon_dir.get(0),Float.TYPE, Float.TYPE);
		     Object reflist[] = new Object[2];
		     
		    float[] dataData = (float[]) data.read();
			float fill = (float) MaskFactory.getFillValue().floatValue();
			
	    	int i;
	    	for ( i = 0; i < rows * cols; ++i) {
	    		    reflist[0] = ref[i];
	    		    reflist[1] = qual[i];
	    			if (dataData[i] == fill) {
	    				stats.countfill();
	    			}
	    			if ( (Boolean) refl.invoke(rf, reflist)) {
	    				dataData[i] = 1;
	    				stats.inc();
                        
	    			}
	    			else {
	    				dataData[i] = fill;
	    				
	    			}
	    		}    		
	    		data.write(dataData);
	    		stats.setTotal(i);
	    		
	    		
	    }
	  
	  public void doMask() throws Exception
	    {
		    
		    int indexOffset = 1;
		    float[] qual = null; 
		    float[] ref =  null;
		      
		    if (file.get_qs_types().get(0).equals("ReferenceConstraintVariable")) {
		    	logger.debug("Using " + quality[0].getName() + " for quality" );
		    	qual = (float[]) quality[0].read();
		    	ref = (float[])  quality[1].read();
		    }
		    else {
		    	logger.debug("Using " + quality[1].getName() + " for quality" );
		    	ref = (float[]) quality[0].read();
		    	qual = (float[])  quality[1].read();
		    	
		    }
		    
	    	
			float[] dataData = (float[]) data.read();
			float fill = (float) MaskFactory.getFillValue().floatValue();
			
	    	int i;
	    		for ( i = 0; i < rows * cols; ++i) {
	    			if (dataData[i] == fill) {
	    				stats.countfill();
	    			}
	    			if (qual[i] == ref[i]) {
	    				dataData[i] = 1;
	    				stats.inc();
                        
	    			}
	    			else {
	    				dataData[i] = fill;
	    				
	    			}
	    		}    		
	    		data.write(dataData);
	    		stats.setTotal(i);
	    		
	    		
	    }
}
