package gov.nasa.gsfc.dqss;

import java.lang.reflect.Method;
import java.util.HashMap;

import ncsa.hdf.object.Dataset;

public class Mask1Q1LevelCon extends Mask {
	
	  DataFile file;
	  String direction;
	  
	public Mask1Q1LevelCon(Dataset data, Dataset[] quality,
			DataFile File, String dir) {
		super(data,quality,dir,File);
		file = File;
		direction = File.qs_direction.get(0);
	}
	
	 public void doMask_reflect() throws Exception
	  {
		    int indexOffset = 1;
		    short[] qualData = null;
		    int[] qualCon = null;
		    try {
		    	/*
		    	 * We decided not to use numcloud - it is already taken into consideration.
		    	 */
		    	if (file.qs_types.get(0).contains("CoordinateConstraintVariable")) {
		    		qualCon = (int[]) quality[0].read();
		    		qualData  = qualData = (short[]) quality[1].read();
		    		logger.warn("Screening with " + quality[1].getName());
		    	}
		    	else {
		    		qualData = (short[]) quality[0].read();
		    		qualCon  = (int[]) quality[1].read();
		    		logger.warn("Screening with " + quality[0].getName());
		    	}
		    }
		    catch(NullPointerException e) {
		    	logger.error("No screening variable types pulled from ontology");
		    }
		    ReflectDirections rf = new ReflectDirections();
		    Method q1 = rf.getMethod(direction,Short.TYPE, Long.TYPE);
		    Method cc = rf.getMethod(file.qs_coordcon_dir.get(0), Integer.TYPE, Integer.TYPE);
		    Object q1list[] = new Object[2];
	    	    
	    	long[] start = data.getStartDims(); // get startDims so we can navigate the layers
	    	
	    	float fill = (float) MaskFactory.getFillValue().floatValue();
	    	
	    	logger.debug("length:" + qualData.length);
	    	logger.debug("Fill value:" + fill);
	    	
	    	float[] dataData = (float[]) data.read();
	    		
	    	q1list[1] = pCrit;
	    	
    		for (int i = 0; i < rows * cols; ++i) {
    			q1list[0] = qualData[i];
    			
    			 if (dataData[i] == fill) {
    				 stats.countfill();
    			 }
    			 else if ( (Boolean) q1.invoke(rf, q1list)) {
    			    		dataData[i] = 1;
		    				stats.inc();
		    	 }
		    	 else {
		    			dataData[i] = fill;
		    	 }		
    		}
    		data.write(dataData);
    	    stats.setTotal((int) (layers * rows * cols));
    	
	    
	  }
	 
	  public void doMask() throws Exception
	    {
		    
		    int indexOffset = 1;
		    short[] qualData = null;
		    int[] qualCon = null;
		    try {
		    	/*
		    	 * We decided not to use numcloud - it is already taken into consideration.
		    	 */
		    	if (file.qs_types.get(0).contains("CoordinateConstraintVariable")) {
		    		qualCon = (int[]) quality[0].read();
		    		qualData  = qualData = (short[]) quality[1].read();
		    		logger.warn("Screening with " + quality[1].getName());
		    	}
		    	else {
		    		qualData = (short[]) quality[0].read();
		    		qualCon  = (int[]) quality[1].read();
		    		logger.warn("Screening with " + quality[0].getName());
		    	}
		    }
		    catch(NullPointerException e) {
		    	logger.error("No screening variable types pulled from ontology");
		    }
	    	
	    	    
	    	long[] start = data.getStartDims(); // get startDims so we can navigate the layers
	    	
	    	float fill = (float) MaskFactory.getFillValue().floatValue();
	    	
	    	logger.debug("length:" + qualData.length);
	    	logger.debug("Fill value:" + fill);
	    	
	    	float[] dataData = (float[]) data.read();
	    		
    		for (int i = 0; i < rows * cols; ++i) {
    			 if (dataData[i] == fill) {
    				 stats.countfill();
    			 }
    			 else if ( qualData[i] <= pCrit) {
    			    		dataData[i] = 1;
		    				stats.inc();
		    	 }
		    	 else {
		    			dataData[i] = fill;
		    	 }		
    		}
    		data.write(dataData);
    	    stats.setTotal((int) (layers * rows * cols));
    	
	    }
}
