package gov.nasa.gsfc.dqss;

import java.lang.reflect.Method;

import ncsa.hdf.object.Dataset;

public class Mask3D1Q extends Mask {
   
    DataFile file = null;
	public Mask3D1Q(Dataset data, Dataset[] quality, DataFile File, String dir ) {
		super(data,quality,dir,File);
	    file = File;
	}
	 public void doMask_reflect() throws Exception
	  {
	    	short[] qualityData = (short[]) quality[0].getData();
	    	long[] start = data.getStartDims(); // get startDims so we can navigate the layers
	    	long nlayer = start[2];
	    	float fill = (float) MaskFactory.getFillValue().floatValue();
	    	
	   	 	ReflectDirections rf = new ReflectDirections();
	   	 	Method refl = rf.getMethod(file.qs_coordcon_dir.get(0),Integer.TYPE, Short.TYPE);
	   	 	Object reflist[] = new Object[2];
	   	 	
	    	for (int layer = 0 ; layer < layers; ++layer) {
	    		start[2] = layer; // this sets the layer outside the class as dims are passed by reference.
	    		logger.debug ("start[2]:" + start[2]);
	    		float[] dataData = (float[]) data.read();
	    		reflist[0] = indexoffset + layer;
	    		
	    		for (int i = 0; i < rows * cols; ++i) {

	    			reflist[1] = qualityData[i];

		    		if (dataData[i] == fill) {
	    				stats.countfill();
	    			}
		    		//if (layer + indexoffset >= qualityData[i]) {
	    			if ( (Boolean) refl.invoke(rf, reflist)) {
	    				dataData[i] = 1;
	    				stats.inc();
	    			}
	    			else {
	    				dataData[i] = fill;
	    			}
	    		   
	    		}
	    		data.write(dataData);
	    		
	    	}
	    	stats.setTotal((int)(layers * rows * cols));
	    	
	  }
	 public void doMask( ) throws Exception
	    {
	    	short[] qualityData = (short[]) quality[0].getData();
	    	long[] start = data.getStartDims(); // get startDims so we can navigate the layers
	    	long nlayer = start[2];
	    	float fill = (float) MaskFactory.getFillValue().floatValue();
	    	
	    	logger.debug("length:" + quality.length);
	    	logger.debug("start[0]:" + start[0]);
	    	logger.debug("start[1]:" + start[1]);
	    	float before;
	    	for (int layer = 0 ; layer < layers; ++layer) {
	    		start[2] = layer; // this sets the layer outside the class as dims are passed by reference.
	    		logger.debug ("start[2]:" + start[2]);
	    		float[] dataData = (float[]) data.read();
	    		
	    		for (int i = 0; i < rows * cols; ++i) {
	    			if (dataData[i] == fill) {
	    				stats.countfill();
	    			}
	    			if (layer + indexoffset >= qualityData[i]) {
	    		
	    				dataData[i] = 1;
	    				stats.inc();
	    			}
	    			else {
	    				dataData[i] = fill;
	    			}
	    		   
	    		}
	    		data.write(dataData);
	    		
	    	}
	    	stats.setTotal((int)(layers * rows * cols));
	    	
	    }
}
