package gov.nasa.gsfc.dqss;

import java.lang.reflect.Method;
import java.util.HashMap;

import ncsa.hdf.object.Dataset;

public class Mask3D2Layer2QConValid extends Mask {
	
	  DataFile file;
	  String direction;
	public Mask3D2Layer2QConValid(Dataset data, Dataset[] quality,
			DataFile File, String dir) {
		super(data,quality,dir,File);
		file = File;
		if (File.qs_direction != null) {
		   	direction = File.qs_direction.get(0);
		}
	}
	 public void doMask_reflect() throws Exception
	  {
		    int indexOffset = 1;
		    short[] qualData = null;
		    int[] qualCon = null;
		    try {
		    	if (file.qs_types.get(0).contains("CoordinateConstraintVariable")) {
		    		qualCon = (int[]) quality[0].read();
		    		qualData  = qualData = (short[]) quality[1].read();
			    	logger.debug("Qual data: " + quality[1].getName() );
			    	logger.debug("Qual constraint: " + quality[0].getName() );
		    	}
		    	else {
		    		qualData = (short[]) quality[0].read();
		    		qualCon  = (int[]) quality[1].read();
			    	logger.debug("Qual data: " + quality[0].getName() );
			    	logger.debug("Qual constraint: " + quality[1].getName() );
		    	}
		    }
		    catch(NullPointerException e) {
		    	logger.error("No screening variable types pulled from ontology");
		    }
		    ReflectDirections rf = new ReflectDirections();
			//quality1 direction
		    Method q1 = rf.getMethod(direction,Short.TYPE, Long.TYPE);
		    Object q1list[] = new Object[2];
		    q1list[1] = pCrit;
		    /*
	    	 * coordinate constraint variable algorithm is too complicated to
	    	 * use reflection.
	    	 */
	    	long[] start = data.getStartDims(); // get startDims so we can navigate the layers
	    	
	    	float fill = (float) MaskFactory.getFillValue().floatValue();
	    	
	    
	    	for (int layer = 0 ; layer < layers; ++layer) {
	    		logger.debug("Doing layer " + layer + " of " + layers + " for " + data.getName());
	    		if (start.length > 2) { // in case this is used by 2 dim dataset.
	    			start[2] = layer; // this sets the layer outside the class as dims are passed by reference.
	    		}
	    		float[] dataData = (float[]) data.read();
	    		
	    		for (int i = 0; i < rows * cols; ++i) {
	    			q1list[0] = qualData[i];
	    			 /*
	    			  * What we are doing here is if the users criteria is <= to Qual_*
	    			  * then we keep the data if the layer (+ indexOffset) is >= QualCon
	    			  */
	    			 logger.debug("Layer:"+ layer + "+" + indexOffset + ">=" +qualCon[i]);
	    			 if (dataData[i] == fill) {
	    				 stats.countfill();
	    			 }
    				 //if ( qualData[i] <= pCrit) {
      	    	     if ( (Boolean) q1.invoke(rf, q1list)) {	 
    					 if ( qualCon[i] == 0) {
	    			    		dataData[i] = fill;
    					 }
    					 else if (qualCon[i] == 1) {
    						 if (layer + indexoffset <= 1) {
	    			    		dataData[i] = 1;
    						 }
    						 else {
    							 dataData[i] = fill;
    						 }
    					 }
    					 else if (qualCon[i] == 2) {
	    			    		dataData[i] = 1;	    				 
    					 }
    				 }
	    			 else {
	    				 dataData[i] = fill;
	    			 }
    				
	    		}
	    		data.write(dataData);
	    		
	    	}
	    	stats.setTotal((int) (layers * rows * cols));
	  }
	  public void doMask() throws Exception
	    {
		    
		    int indexOffset = 1;
		    short[] qualData = null;
		    int[] qualCon = null;
		    try {
		    	if (file.qs_types.get(0).contains("CoordinateConstraintVariable")) {
		    		qualCon = (int[]) quality[0].read();
		    		qualData  = qualData = (short[]) quality[1].read();
			    	logger.debug("Qual data: " + quality[1].getName() );
			    	logger.debug("Qual constraint: " + quality[0].getName() );
		    	}
		    	else {
		    		qualData = (short[]) quality[0].read();
		    		qualCon  = (int[]) quality[1].read();
			    	logger.debug("Qual data: " + quality[0].getName() );
			    	logger.debug("Qual constraint: " + quality[1].getName() );
		    	}
		    }
		    catch(NullPointerException e) {
		    	logger.error("No screening variable types pulled from ontology");
		    }
	    	
	    
	    	long[] start = data.getStartDims(); // get startDims so we can navigate the layers
	    	
	    	float fill = (float) MaskFactory.getFillValue().floatValue();
	    	
	    	logger.debug("length:" + qualData.length);
	    	logger.debug("Fill value:" + fill);
	    	float before;
	    	for (int layer = 0 ; layer < layers; ++layer) {
	    		logger.debug("Doing layer " + layer + " of " + layers + " for " + data.getName());
	    		if (start.length > 2) { // in case this is used by 2 dim dataset.
	    			start[2] = layer; // this sets the layer outside the class as dims are passed by reference.
	    		}
	    		float[] dataData = (float[]) data.read();
	    		
	    		for (int i = 0; i < rows * cols; ++i) {
	    			 before = dataData[i];
	    			 /*
	    			  * What we are doing here is if the users criteria is <= to Qual_*
	    			  * then we keep the data if the layer (+ indexOffset) is >= QualCon
	    			  */
	    			 logger.debug("Layer:"+ layer + "+" + indexOffset + ">=" +qualCon[i]);
	    			 if (dataData[i] == fill) {
	    				 stats.countfill();
	    			 }
    				 if ( qualData[i] <= pCrit) {
    					 if ( qualCon[i] == 0) {
	    			    		dataData[i] = fill;
    					 }
    					 else if (qualCon[i] == 1) {
    						 if (layer + indexoffset <= 1) {
	    			    		dataData[i] = 1;
    						 }
    						 else {
    							 dataData[i] = fill;
    						 }
    					 }
    					 else if (qualCon[i] == 2) {
	    			    		dataData[i] = 1;	    				 
    					 }
    				 }
	    			 else {
	    				 dataData[i] = fill;
	    			 }
    				
	    		}
	    		data.write(dataData);
	    		
	    	}
	    	stats.setTotal((int) (layers * rows * cols));
	    	
	    }
}
