package gov.nasa.gsfc.dqss;

import java.lang.reflect.Method;
import java.util.HashMap;

import ncsa.hdf.object.Dataset;

public class Mask5D1Q1Con extends Mask {
	
	  //long[] mins    = null;
	  //long[] maxs    = null;
	  DataFile file;   
	  String direction;
	public Mask5D1Q1Con(Dataset data, Dataset[] quality, String dir, DataFile File ) {
		super(data,quality,dir,File);
	    file = File;
	    if (File.qs_direction != null) {
	    	direction = File.qs_direction.get(0);
	    }
	}
	 /*
	  * PCldTopStd and TCldTopStd need to be redone to use a 3 dimension
	  * version of this algorithm
	  * 
	  */
	  public void doMask_reflect() throws Exception
	  {
		    int indexOffset = 1;
		    short[] qualData = null;
		    int[] qualCon = null;
		    if (file.get_qs_types().get(0).equals("CoordinateConstraintVariable")) {
		    	qualCon = (int[]) quality[0].read();
		    	qualData  = qualData = (short[]) quality[1].read();
		    	logger.debug("Qual data: " + quality[1].getName() );
		    	logger.debug("Qual constraint: " + quality[0].getName() );
		      }
		    else {
		    	qualCon = (int[]) quality[1].read();
		    	qualData  = qualData = (short []) quality[0].read();
		    	logger.debug("Qual data: " + quality[0].getName() );
		    	logger.debug("Qual constraint: " + quality[1].getName() );
		    	
		    }
		    ReflectDirections rf = new ReflectDirections();
		    Method q1 = rf.getMethod(direction,Short.TYPE, Long.TYPE);
		    Object q1list[] = new Object[2];
		    q1list[1]       = pCrit;
	    	/*
	    	 * coordinate constraint variable algorithm is too complicated to
	    	 * use reflection.
	    	 */
	    	
	    	long[] start = data.getStartDims(); // get startDims so we can navigate the layers
	    	/*
	    	 * If there are 3 dimensions then
	    	 * start[2] = layers  (rows and cols in [0] and [1]
	    	 * 5 Dim: 3x3 = 9 AIRS pixels in single AMSU pixel
	    	 *        2 could layers. numcloud determines how many of the 2 layers apply.
	    	 * If there are 5 dimensions (30,45,3,3,2) then
	    	 * start[2] and start[3] are somehow the 9 AIRS pixels and
	    	 * start[4] are the two layers.  But how?
	    	 * How will I read the 9 pixels?
	    	 * each ith pixel in each dimension constitute one of the 18 pixels in the
	    	 * 2 layers.
	    	 */
	    	
	    	
	    	float fill = (float) DQSS.getFillValue();
	    	
	    	logger.debug ("length:" + qualData.length);
	    	logger.debug ("Fill value:" + fill);
	    	logger.debug ("Layers:" + layers); // 3
	    	float before;
	    	for (int layer = 0 ; layer < layers; ++layer) {
	    		start[2] = layer; // this sets the layer outside the class as dims are passed by reference.
	    	    for (int airsdim = 0; airsdim < dims4; ++airsdim) {
	    	    	start[3] = airsdim;
	    	    	for (int cldlyr = 0 ; cldlyr < dims5; ++ cldlyr) {
	    	    		start[4] = cldlyr;
	    	    		float[] dataData = (float[]) data.read();
	    	    		int count = 0;
	    	    		for (int i = 0; i < dataData.length; ++i) {
	    	    			if (dataData[i] == fill) {
	    	    				stats.countfill();
	    	    			}
	    	    			/*
	    	    			 * The test below seems to indicate that if numCloud[10] says 1 then
	    	    			 * data[10] at each layer,airsdim,cldlyr are the 18 values which
	    	    			 * constitute the 2 layers of 9 airs pixels in an amsu pixel.
	    	    			 */
	    	    			/*
	    	    			 * Revision. We want to keep CldFrcStd values of 0 and not turn them
	    	    			 * to fill
	    	    			 */
	    	    			//if ( qualData[i] <= pCrit) { 
	    	    			q1list[0] = qualData[i];
	    	    			if ( (Boolean) q1.invoke(rf, q1list)) {
	    	    				if (qualCon[i] == 2 ) {
	    	    				   dataData[i] = 1;
	    	    				   stats.inc();
	    	    				}
	    	    				else if (qualCon[i] == 0){
	    	    					if (dataData[i] > 0 ) {
	    	    						logger.warn("NumCloud says " + qualCon[i] + ", so no clouds, but CldFrcStd has:" + dataData[i]);
	    	    						dataData[i] = fill;
	    	    					}
	    	    					else {
	    	    						dataData[i] = 1;
	    	    					}
	    	    				
	    	    				}
	    	    				else if (qualCon[i] == 1) {
	    	    					if (cldlyr == 0) {
	    	    						dataData[i] = 1;
	    	    						stats.inc();
	    	    					}
	    	    					else {
	    	    						if (dataData[i] > 0 ) {
		    	    						logger.warn("NumCloud says " + qualCon[i] + ", so no clouds, but CldFrcStd has:" + dataData[i]);
		    	    						dataData[i] = fill;
		    	    					}
	    	    						else {
	    	    							dataData[i] = 1;
	    	    						}
	    	    						
	    	    					}
	    	    				}
	    	    				
	    	    			}
	    	    			else {
	    	    				dataData[i] = fill;
	    	    			}
		    	    		
	    	    		}
	    	    		data.write(dataData);
	    				//logger.debug("domask:"+ layer + ":" + airsdim + ":" + cldlyr + ":"  +  dataData.length + ":" + count);
	    	    	}
	    	    }
	    			
	    	}
	    	stats.setTotal((int) (layers * rows * cols * 3 * 2));
	    	
	  }
	  public void doMask() throws Exception
	    {
	
		    int indexOffset = 1;
		    short[] qualData = null;
		    int[] qualCon = null;
		    if (file.get_qs_types().get(0).equals("CoordinateConstraintVariable")) {
		    	qualCon = (int[]) quality[0].read();
		    	qualData  = qualData = (short[]) quality[1].read();
		    	logger.debug("Qual data: " + quality[1].getName() );
		    	logger.debug("Qual constraint: " + quality[0].getName() );
		      }
		    else {
		    	qualCon = (int[]) quality[1].read();
		    	qualData  = qualData = (short []) quality[0].read();
		    	logger.debug("Qual data: " + quality[0].getName() );
		    	logger.debug("Qual constraint: " + quality[1].getName() );
		    	
		    }
		  
	    	
	    	
	    	long[] start = data.getStartDims(); // get startDims so we can navigate the layers
	    	/*
	    	 * If there are 3 dimensions then
	    	 * start[2] = layers  (rows and cols in [0] and [1]
	    	 * 5 Dim: 3x3 = 9 AIRS pixels in single AMSU pixel
	    	 *        2 could layers. numcloud determines how many of the 2 layers apply.
	    	 * If there are 5 dimensions (30,45,3,3,2) then
	    	 * start[2] and start[3] are somehow the 9 AIRS pixels and
	    	 * start[4] are the two layers.  But how?
	    	 * How will I read the 9 pixels?
	    	 * each ith pixel in each dimension constitute one of the 18 pixels in the
	    	 * 2 layers.
	    	 */
	    	
	    	
	    	float fill = (float) DQSS.getFillValue();
	    	
	    	logger.debug ("length:" + qualData.length);
	    	logger.debug ("Fill value:" + fill);
	    	logger.debug ("Layers:" + layers); // 3
	    	float before;
	    	for (int layer = 0 ; layer < layers; ++layer) {
	    		start[2] = layer; // this sets the layer outside the class as dims are passed by reference.
	    	    for (int airsdim = 0; airsdim < dims4; ++airsdim) {
	    	    	start[3] = airsdim;
	    	    	for (int cldlyr = 0 ; cldlyr < dims5; ++ cldlyr) {
	    	    		start[4] = cldlyr;
	    	    		float[] dataData = (float[]) data.read();
	    	    		int count = 0;
	    	    		for (int i = 0; i < dataData.length; ++i) {
	    	    			if (dataData[i] == fill) {
	    	    				stats.countfill();
	    	    			}
	    	    			/*
	    	    			 * The test below seems to indicate that if numCloud[10] says 1 then
	    	    			 * data[10] at each layer,airsdim,cldlyr are the 18 values which
	    	    			 * constitute the 2 layers of 9 airs pixels in an amsu pixel.
	    	    			 */
	    	    			/*
	    	    			 * Revision. We want to keep CldFrcStd values of 0 and not turn them
	    	    			 * to fill
	    	    			 */
	    	    			if ( qualData[i] <= pCrit) { 
	    	    				if (qualCon[i] == 2 ) {
	    	    				   dataData[i] = 1;
	    	    				   stats.inc();
	    	    				}
	    	    				else if (qualCon[i] == 0){
	    	    					if (dataData[i] > 0 ) {
	    	    						logger.warn("NumCloud says " + qualCon[i] + ", so no clouds, but CldFrcStd has:" + dataData[i]);
	    	    						dataData[i] = fill;
	    	    					}
	    	    					else {
	    	    						dataData[i] = 1;
	    	    					}
	    	    				
	    	    				}
	    	    				else if (qualCon[i] == 1) {
	    	    					if (cldlyr == 0) {
	    	    						dataData[i] = 1;
	    	    						stats.inc();
	    	    					}
	    	    					else {
	    	    						if (dataData[i] > 0 ) {
		    	    						logger.warn("NumCloud says " + qualCon[i] + ", so no clouds, but CldFrcStd has:" + dataData[i]);
		    	    						dataData[i] = fill;
		    	    					}
	    	    						else {
	    	    							dataData[i] = 1;
	    	    						}
	    	    						
	    	    					}
	    	    				}
	    	    				
	    	    			}
	    	    			else {
	    	    				dataData[i] = fill;
	    	    			}
		    	    		
	    	    		}
	    	    		data.write(dataData);
	    				//logger.debug("domask:"+ layer + ":" + airsdim + ":" + cldlyr + ":"  +  dataData.length + ":" + count);
	    	    	}
	    	    }
	    			
	    	}
	    	stats.setTotal((int) (layers * rows * cols * 3 * 2));
	    	
	    }
}
