package gov.nasa.gsfc.dqss;

import java.lang.reflect.Method;

import org.apache.log4j.Logger;

public class ReflectDirections {
	
    protected ReflectDirections rfldir = null;
	protected Class reflectedClass = null;
	protected Object reflist[] = new Object[2];
	static Logger logger = Logger.getLogger(ReflectDirections.class.getName());
	
	
	
	public ReflectDirections(){
		 try {
			reflectedClass = Class.forName("gov.nasa.gsfc.dqss.ReflectDirections");
		} catch (ClassNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
		}
				
	 }
	
	public boolean lt(int a, int b) {
		if (a < b ) {
			return true;
		}
		else {
			return false;
		}
	}
	public boolean lt(float a, float b) {
		if (a < b ) {
			return true;
		}
		else {
			return false;
		}
	}	
	public boolean gt(int a, int b) {
		if (a > b ) {
			return true;
		}
		else {
			return false;
		}
	}
	
	public boolean le(int a, int b) {
		if (a <= b ) {
			return true;
		}
		else {
			return false;
		}
	}
	
	public boolean le(short a, long b) {
		if (a <= b ) {
			return true;
		}
		else {
			return false;
		}
	}
	public boolean ge(int a, int b) {

		if (a >= b ) {
			return true;
		}
		else {
			return false;
		}
	}
	public boolean ge(int a, long b) {

		if (a >= b ) {
			return true;
		}
		else {
			return false;
		}
	}
	public boolean ge(float a, float b) {
	
		if (a >= b ) {
			return true;
		}
		else {
			return false;
		}
	}
	public boolean ge(int a, short b) {

		if (a >= b ) {
			return true;
		}
		else {
			return false;
		}
	}
	public boolean eq(int a, int b) {
		if (a == b ) {
			return true;
		}
		else {
			return false;
		}
	}
	public boolean eq(float a, float b) {
		if (a == b ) {
			return true;
		}
		else {
			return false;
		}
	}
	public Method getMethod(String direction, Class typea, Class typeb) {
			   Method refl = null;
			   Class types[] = new Class[2];
			   types[0] = typea;
			   types[1] = typeb;
		
		    	try {
		    		if (direction.contains("negative") ) {
		    			refl = reflectedClass.getMethod("le", types);
		    		}
		    		else if (direction.contains("positive") ) {
		    			refl = reflectedClass.getMethod("ge", types);
		    		}
		    		else if (direction.contains("lessThan") ) {
		    			refl = reflectedClass.getMethod("le", types);
		    		}
		    		else if (direction.contains("equals") ) {
		    			refl = reflectedClass.getMethod("eq", types);
		    		}
		    		else if (direction.contains("greaterThanOrEqualTo") ) {
		    			refl = reflectedClass.getMethod("ge", types);
		    		}
		    		else {
		    			System.err.println("Could not find method for:" + direction);
		    			System.exit(2);
		    		}
		    		
		    		
				} catch (SecurityException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (NoSuchMethodException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					logger.error("Could not find a reflection method for direction:" + direction);
				}
				logger.debug(refl.getName());
		return refl;
	}
}
