package gov.nasa.gsfc.dqss.test;

import gov.nasa.gsfc.dqss.DataFile;
import gov.nasa.gsfc.dqss.Masker;
import gov.nasa.gsfc.dqss.Statistics;
import ncsa.hdf.object.Dataset;



public class TwoQVars {
        
	    int indexoffset = 1;
	    int pCrit = -1;
	    
	    String[] qs_vars = null;
	    String[] dims    = null;
	    long[] mins    = null;
	    long[] maxs    = null;
	    Statistics stats =  null;
	    public TwoQVars() {}
	    
		public TwoQVars(String criteria, String[]qs, 
				String[]dim, long[] min, long[] max) {

			
			pCrit =   Integer.parseInt(criteria);
			qs_vars = qs;	
			mins = min;
			maxs = max;
			dims = dim;
			stats = new Statistics();
			           
		}
		
		
		
		
		public void doThisMask(Dataset parameter, Dataset[] dqs ) {
			try {
	    		
				Dim3TwoQS(parameter,dqs,3,45,30,28);
				//displayValues(45,30,28,dtairstd);
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		  private void Dim3TwoQS(Dataset parameter, Dataset[] qs,
				  int rank,int rows, int cols, int layers) throws Exception
		    {
			    int pCrit = 1;
			    int indexOffset = 1;
		    	short[] qual1 = (short[]) qs[0].read();
		    	long[] qual1Limits = { mins[0], maxs[0] };
		    	long[] qual2Limits = { mins[1], maxs[1] };
		    	
		    	System.out.println("Qual 1: " + qs[0].getName() + " " + qual1Limits[0] + "," + qual1Limits[1]);
		    	
		    	
		    	short[] qual2 = (short[]) qs[1].read();
		    	System.out.println("Qual 2: " + qs[1].getName() + " " + qual2Limits[0] + "," + qual2Limits[1]);
		    
		    	long[] start = parameter.getStartDims(); // get startDims so we can navigate the layers
		    	long nlayer = start[2];
		    	float fill = (float) DataFile.getFillValue(parameter);
		    	
		    	Masker.ReportError ("length:" + qual1.length,2);
		    	Masker.ReportError ("Fill value:" + fill,2);
		    	float before;
		    	for (int layer = 0 ; layer < layers; ++layer) {
		    		start[2] = layer; // this sets the layer outside the class as dims are passed by reference.
		    		float[] data = (float[]) parameter.read();
		    		
		    		for (int i = 0; i < rows * cols; ++i) {
		    			 before = data[i];
		    			 if (data[i] == fill) {
		    				 // nothing to do
		    			 }
		    			 else if (layer + indexOffset >= qual1Limits[0] && layer + indexOffset < qual1Limits[1]) {
		    				 if ( qual1[i] <= pCrit) {
		    			    		
				    				data[i] = 1;
				    				stats.inc();
				    			}
				    			else {
				    				data[i] = fill;
				    			}		
		    				    if (i % 100 == 0) {
		    				          Masker.ReportError( layer + indexOffset + " between " + qual1Limits[0] + " and " + qual1Limits[1] +  
		    						 "and qual1[i] = " + qual1[i] + " Therefore: this pixel = " + data[i] + " but  before it was:" + before,2);
		    				    }
		    			 }
		    			 else {
		    				 if (qual2[i] <= pCrit) {
		    			    		
				    				data[i] = 1;
				    			}
				    			else {
				    				data[i] = fill;
				    			}
		    				 	if (i % 100 == 0) {
		    				 		Masker.ReportError( layer + indexOffset + " between " + qual2Limits[0] + " and " + qual2Limits[1] +  
			    					 "and qual2[i] = " + qual2[i] + " Therefore: this pixel = " + data[i] + " but  before it was:" + before,2);
		    				 	}
		    			    
		    		    }
		    		}
		    		parameter.write(data);
		    		
		    	}
		    	stats.setTotal(layers * rows * cols);
		    	
		    }
}
